package com.gic.haoban.manage.service.service.hm;

import com.gic.api.base.commons.Page;
import com.gic.haoban.manage.service.pojo.bo.hm.HmPageRelationBO;
import com.gic.haoban.manage.service.pojo.qo.HmPageRelationQO;

import java.util.List;

/**
 * @Author MUSI
 * @Date 2022/7/1 5:37 PM
 * @Description
 * @Version
 **/
public interface HmPageRelationService {


    /**
     * 保存活码 与落地页的引用关系
     *
     * @param hmPageRelationBO
     *
     * @return true 保存成功
     */
    boolean savePageRelation(HmPageRelationBO hmPageRelationBO);

    /**
     * 更新 落地页关联状态
     * referId pageId
     *
     * @param hmPageRelationBO
     * @return
     */
    boolean updateRelationStatus(HmPageRelationBO hmPageRelationBO);

    /**
     * 根据落地页模板code 查询关联的引用方
     *
     * @param pageCode
     * @return
     */
    List<HmPageRelationBO> queryPageRelation(String pageCode);

    /**
     * 链接code/模板名称 条件查询
     * @param hmPageRelationQo
     * @return
     */
    Page<HmPageRelationBO> queryPageRelationWithSearchText(HmPageRelationQO hmPageRelationQo);

    /**
     * 统计pageCode 被引用的总数
     * @param pageCode
     * @return
     */
    Integer countPageTemplateRelation(String pageCode);
}
