package com.gic.haoban.manage.service.service.hm;

import com.gic.api.base.commons.Page;
import com.gic.haoban.manage.service.pojo.bo.hm.HmWelcomeRelationBO;
import com.gic.haoban.manage.service.pojo.bo.welcome.WelcomeDetailBO;
import com.gic.haoban.manage.service.pojo.qo.WelcomeRelationQO;

import java.util.List;

/**
 * @Author MUSI
 * @Date 2022/7/4 5:49 PM
 * @Description
 * @Version
 **/
public interface WelcomeRelationService {

    /**
     * 查询欢迎语关联关系
     * @param referId
     * @param status
     * @return
     */
    HmWelcomeRelationBO queryWelcomeRelation(String referId, Integer status);

    /**
     * 条件查询 欢迎语引用列表
     * @param welcomeRelationQo
     * @return
     */
    List<HmWelcomeRelationBO> queryWelcomeRelationList(WelcomeRelationQO welcomeRelationQo);

    /**
     * 分页查询 欢迎语关联列表
     * @param welcomeRelationQo
     * @return
     */
    Page<HmWelcomeRelationBO> queryWelcomeRelationPage(WelcomeRelationQO welcomeRelationQo);

    /**
     * 根据 关联方的code 获取关联的欢迎语
     * @param referId
     * @return
     */
    WelcomeDetailBO queryHmWelcomeWithReferId(String referId);

    /**
     * 保存欢迎语引用关联关系
     * @param hmWelcomeRelationBO
     * @return
     */
    Boolean saveHmWelcomeRelation(HmWelcomeRelationBO hmWelcomeRelationBO);

    /**
     * 修改关联关系状态
     *
     * @param hmWelcomeRelationBO
     *
     * @see com.gic.haoban.manage.api.enums.WelcomeRelationStatusEnum
     * @return
     */
    Boolean updateWelcomeRelationStatus(HmWelcomeRelationBO hmWelcomeRelationBO);
}
