package com.gic.haoban.manage.service.service.out.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.haoban.manage.api.dto.KeyDataDTO;
import com.gic.haoban.manage.api.enums.KeyDataEnum;
import com.gic.haoban.manage.api.service.KeyDataApiService;
import com.gic.haoban.manage.service.errorcode.HaoBanErrCode;
import com.gic.haoban.manage.service.service.KeyDataService;

@Service("keyDataApiService")
public class KeyDataApiServiceImpl implements KeyDataApiService {

    @Autowired
    private KeyDataService keyDataService;

    @Override
    public ServiceResponse<String> saveMobileData(String enterpiseId , Long linkId, String mobile) {
        JSONObject json = new JSONObject();
        json.put("ph", mobile);
        json.put("ljid", linkId);
        KeyDataDTO keyData = this.keyDataService.saveData(enterpiseId,String.valueOf(linkId), json.toString(), KeyDataEnum.MOBILE);
        return ServiceResponse.success(keyData.getDataKey());
    }

    @Override
    public ServiceResponse<String> getDataByKey(String key, KeyDataEnum dataEnum) {
        KeyDataDTO data = this.keyDataService.getDataByKey(key, dataEnum, null);
        if (null != data) {
            return ServiceResponse.success(data.getData());
        }
        return ServiceResponse.failure(HaoBanErrCode.ERR_OTHER.getCode(), "数据不存在");
    }

    @Override
    public ServiceResponse<String> getMobile(Long linkId, String key) {
        KeyDataDTO data = this.keyDataService.getDataByKey(key, KeyDataEnum.MOBILE, String.valueOf(linkId));
        if (null != data) {
            JSONObject json = JSON.parseObject(data.getData());
            return ServiceResponse.success(json.getString("ph"));
        }
        return null;
    }

}
