package com.gic.haoban.manage.web.controller.hm;


import cn.hutool.core.convert.Convert;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.haoban.base.api.common.PageResult2;
import com.gic.haoban.base.api.common.pojo.dto.WebLoginDTO;
import com.gic.haoban.common.utils.AuthWebRequestUtil;
import com.gic.haoban.manage.api.dto.hm.HmQrcodeDTO;
import com.gic.haoban.manage.api.dto.hm.HmQrcodeListDTO;
import com.gic.haoban.manage.api.dto.qdto.hm.HmQrcodeListQDTO;
import com.gic.haoban.manage.api.dto.qdto.hm.HmQrcodeQDTO;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.api.service.hm.HmQrcodeApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 活码(TabHaobanHmQrcode)表控制层
 *
 * @author mozhu
 * @since 2022-07-04 15:42:20
 */
@RestController
@RequestMapping("/hm/qrcode")
public class HmQrcodeController {
    @Autowired
    private HmQrcodeApiService hmQrcodeApiService;
    @Autowired
    private StaffApiService staffApiService;

    /**
     * 新增
     * @param HmQrcodeQDTO
     * @return
     */
    @RequestMapping(value = "add", method = RequestMethod.POST)
    public RestResponse add(@RequestBody HmQrcodeQDTO HmQrcodeQDTO) {
        WebLoginDTO loginUser = AuthWebRequestUtil.getLoginUser();
        HmQrcodeQDTO.setCreatorId(loginUser.getClerkId());
        HmQrcodeQDTO.setCreatorName(loginUser.getClerkName());
        HmQrcodeQDTO.setModifierId(loginUser.getClerkId());
        HmQrcodeQDTO.setModifierName(loginUser.getClerkName());
        HmQrcodeQDTO.setWxEnterpriseId(loginUser.getWxEnterpriseId());
        HmQrcodeQDTO.setEnterpriseId(loginUser.getEnterpriseId());
        this.hmQrcodeApiService.add(HmQrcodeQDTO);
        return RestResponse.successResult();
    }

    /**
     * 修改
     * @param HmQrcodeQDTO
     * @return
     */
    @RequestMapping(value = "update", method = RequestMethod.POST)
    public RestResponse update(@RequestBody HmQrcodeQDTO HmQrcodeQDTO) {
        WebLoginDTO loginUser = AuthWebRequestUtil.getLoginUser();
        HmQrcodeQDTO.setCreatorId(loginUser.getClerkId());
        HmQrcodeQDTO.setCreatorName(loginUser.getClerkName());
        HmQrcodeQDTO.setModifierId(loginUser.getClerkId());
        HmQrcodeQDTO.setModifierName(loginUser.getClerkName());
        HmQrcodeQDTO.setWxEnterpriseId(loginUser.getWxEnterpriseId());
        HmQrcodeQDTO.setEnterpriseId(loginUser.getEnterpriseId());
        this.hmQrcodeApiService.update(HmQrcodeQDTO);
        return RestResponse.successResult();
    }

    /**
     * 列表
     * @param hmQrcodeListQDTO
     * @return
     */
    @RequestMapping(value = "list", method = RequestMethod.POST)
    public RestResponse<PageResult2<HmQrcodeListDTO>> update(@RequestBody HmQrcodeListQDTO hmQrcodeListQDTO) {
        WebLoginDTO loginUser = AuthWebRequestUtil.getLoginUser();
        List<String> storeList =  staffApiService.getHaoBanStoreIdsRolesByClerkId(loginUser.getClerkId(), loginUser.getWxEnterpriseId());
        if (CollectionUtils.isEmpty(storeList)) {
            return RestResponse.failure(Convert.toStr(HaoBanErrCode.ERR_100007.getCode()),HaoBanErrCode.ERR_100007.getMsg());
        }
        if (!storeList.contains("-1")) {
            hmQrcodeListQDTO.setStoreIdList(storeList);
        }
        return RestResponse.successResult(this.hmQrcodeApiService.queryListByPage(hmQrcodeListQDTO));
    }

    /**
     * 详情
     * @param hmId
     * @return
     */
    @RequestMapping(value = "detail", method = RequestMethod.GET)
    public RestResponse detail(Long hmId) {
        HmQrcodeDTO hmQrcodeDTO = this.hmQrcodeApiService.queryById(hmId);
        return RestResponse.successResult(hmQrcodeDTO);
    }

    /**
     * 作废
     * @param hmId
     * @return
     */
    @RequestMapping(value = "del", method = RequestMethod.DELETE)
    public RestResponse del(Long hmId) {
        this.hmQrcodeApiService.delById(hmId);
        return RestResponse.successResult();
    }
}

